#** raccess4vbox-1.12.tcl **
# ** 05-Jun-98 Gerrit Pape <Gerrit@homePape.isdn.cs.tu-berlin.de> Berlin Germany

# what do I say
set text(repeat_rec)        "starting new record"
set text(err_run_ext)       "extern program did not return 0"
set text(err_getty_play)    "while getty playing message"
set text(err_getty_rec)     "while getty recording message"
set text(err_getty_wait)    "while getty waiting"
set text(err_no_act)        "no action found for this code"
set text(err_input_no_text) "no text given for input run extern"

set text(rcontrol_recnew_intro) \
   {record new standard message ,,,,, start after the beep and stop with 0}
set text(rcontrol_recnew_repeatrec) \
   {repeating your message ,,,,, confirm with 8 and drop with 2}
set text(rcontrol_recnew_err_backupstd) \
   {back up of standard message failed, no changes made}
set text(rcontrol_recnew_err_createstd) \
   {writing new standard message failed ,,,, no garantee of further functions}
set text(rcontrol_recnew_confirm)       {accepted the new standard message}
set text(rcontrol_recnew_drop)          {no changes ,,, exiting}

# Tuning
set tuning(rcfile)     "raccess.conf"  ;# searched in spooldir/<user>/
set tuning(say_path)   /usr/bin/say
set tuning(say_flag)   "-q -x 2000 -f 8"   ;# try yourself 
set tuning(say_breath) ",,,,,"
set tuning(say_append) ",,,,,,,,,"
set tuning(temp_file)  /tmp/vbox20-[pid]-1.tmp
set tuning(touch_path) /usr/bin/touch
set tuning(logging)    2
  set tuning(log_file)  raccess.log    ;# placed in spooldir/<user>

set tuning(returnsequenz) 0

#
proc raccess_log { level msg } {
    global tuning
    if { $level <= $tuning(logging) } {
	puts $tuning(log_file_no) "[ clock format [ clock seconds ] ]: $msg"
	flush $tuning(log_file_no)
    }
}

# 
proc playmessage { message { flag TRUE } } {
    global action text atext tuning
    if { $flag == "TRUE" } {
	raccess_log 1 "Play $message"
	set what [ vbox_put_message $message ]
	if { $what != "OK" } {
	    if { $what == "HANGUP" } {
		raccess_log 1 "HANGUP"
		return "HANGUP"
	    }
	    if { $what == "ERROR" } {
		raccess_log 1 "ERROR vbox_put_message"
		return [ handle_error $text(err_getty_play) ]
	    }
	    if { $tuning(returnsequenz) } {
		if { [ string length $what ] > 3 } {
		    raccess_log 2 "returning SEQUENZ $what"
		    return "$what"
		}
	    }
	    if [ info exists action($what) ] {
		raccess_log 1 "GOT SEQUENZ $what"
		if { [ info exists atext($what) ] } {
		    playtext $atext($what)
		}
		return [ eval $action($what) ]
	    } else {
		raccess_log 1 "GOT SEQUENZ $what - action not found!!"
                return [ handle_error $text(err_no_act) ]
	    }
	}
    }
    raccess_log 1 "OK"
    return "OK"
}

proc recmessage { message reclength { flag "TRUE" } } {
    global action vbox_msg_timeout text atext
    if { $flag == "TRUE" } {
	raccess_log 1 "Record $message"
	set what [ vbox_get_message $message $reclength ]
	if { $what != "OK" } {
	    if { $what == "HANGUP" } {
		raccess_log 1 "HANGUP"
		return "HANGUP"
	    }
	    if { $what == "TIMEOUT" } {
		raccess_log 1 "TIMEOUT"
		return [ playmessage $vbox_msg_timeout ]
		}
	    if { $what == "ERROR" } {
		raccess_log 1 "ERROR vbox_get_message"
		return [ handle_error $text(err_getty_rec) ]
	    }
	    if [ info exists action($what) ] {
		raccess_log 1 "GOT SEQUENZ $what"
                if { [ info exists atext($what) ] } {
                    playtext $atext($what)
                }
		return [ eval $action($what) ]
	    } else {
		raccess_log 1 "GOT SEQUENZ $what - action not found!!"
		return [ handle_error $text(err_no_act) ]
	    }
	}
    }
    raccess_log 1 "OK"
    return "OK"
}
# 
proc wait { seconds } {
    global action text atext tuning
    raccess_log 1 "waiting $seconds seconds"
    set what [ vbox_wait $seconds ]
    if { $what != "HANGUP" } {
	if { $what == "ERROR" } {
	    raccess_log 1 "ERROR vbox_wait"
	    return [ handle_error $text(err_getty_wait) ]
	}
	if { $what == "TIMEOUT" } {
	    raccess_log 2 "TIMEOUT vbox_wait"
	    if [ info exists action(TIMEOUT) ] {
		if [ info exists atext(TIMEOUT) ] {
		    playtext $atext(TIMEOUT)
		}
		return [ eval $action($what) ]
	    } else {
		return "REPEAT"
	    }
	}
	if { $what == "OK" } {
	    raccess_log 2 "OK vbox_wait"
	    return "REPEAT"
	}
	if { $tuning(returnsequenz) } {
	    if { [ string length $what ] > 3 } {
		raccess_log 2 "returning SEQUENZ $what"
		return "$what"
	    }
	}
	if [ info exists action($what) ] {
	    raccess_log 1 "GOT SEQUENZ $what"
	    if [ info exists atext($what) ] {
		playtext $atext($what)
	    }
	    return [ eval $action($what) ]
	} else {
	    raccess_log 1 "GOT SEQUENZ $what - action not found!!"
	    return [ handle_error $text(err_no_act) ]
	}
    }
    raccess_log 1 "HANGUP"
    return "HANGUP"
}

#
proc handle_error { { why "no more spezification given" } } {
    global no_of_errors
    incr no_of_errors
    raccess_log 1 "ERROR No. $no_of_errors: $why"
    if { $no_of_errors >= 9 } {
	raccess_log 1 "too many errors! hanging up myself..."
	return "HANGUP"
    }
    if { [ set what [ playtext error $why ] ] == "HANGUP" } {
	return "HANGUP"
    }
    if { $what == "ERROR" } {
	raccess_log 1 "cannot report error! hanging up by myself..."
	return "HANGUP"
    }
    raccess_log 2 "ERROR reported - REPEAT"
    return "REPEAT"
}

# 
proc playtext { string args } {
    global vbox_var_bindir
    upvar #0 tuning(say_path) say tuning(say_flag) flag \
	    tuning(say_append) append tuning(temp_file) file
    raccess_log 1 "playtext $string $args"

    if { [ string index $string 0 ] == "@" } {
	    set what [ playmessage [ string range $string 1 end ] ]
    } elseif { [ string index $string 0 ] == "&" } {
	if [ catch { open [ string range $string 1 end ] r } fd ] {
	    return [ handle_error \
		    "cannot open [ string range $string 1 end ] $fd" ]
	}
	while { [ set line [ gets $fd that ] ] >= 0 } {
	    if { [ set what [ playtext $that ] ] == "HANGUP" } {
		return "HANGUP"
	    }
	}
	close $fd
    } elseif { [ string index $string 0 ] == "|" } {
	set do "run_extern [ string range $string 1 end ]"
	return [ eval $do ]
    } else {
	if [ catch { eval exec -- $say $flag -a -o - $string $args $append | \
		$vbox_var_bindir/autovbox | cat > $file 2> /dev/null } that ] {
	    raccess_log 1 "ERROR convert text2au2vbox > $file: $that"
	    if { [ string compare $string error ] == 0 } {
		return "ERROR"
	    }
	    return [ handle_error "cannot convert text to soundfile: $that" ]
	}
	set what [ playmessage [ subst $file ] ]
	if [ catch { file delete $file } ] {
	    raccess_log 1 "ERROR couldnot remove $file"
	}
    }
    return "$what"
}
# 
proc run_extern { cmd args } {
    global text
    upvar #0 tuning(temp_file) file

    raccess_log 2 "starting $cmd $args"
    if [ catch { eval exec -keepnewline -- $cmd $args } that ] {
	if { [ handle_error $text(err_run_ext) ] == "HANGUP" } {
	    return "HANGUP"
	}
    }
    foreach line [ split "$that" \n ] {
	if { [ playtext $line ] == "HANGUP" } {
	    return "HANGUP"
	}
    }
    return "REPEAT"
}

#
proc input_run_extern { cmd } {
    global text tuning
    upvar #0 input_run_extern_action i_action \
	    input_run_extern_action_text i_text
    set tuning(returnsequenz) 1
    set input dummy
    install_actions_texts i_action backup i_text tbackup
    vbox_breaklist add ALL
    raccess_log 2 "start input_run_extern"
    while { 1 } {
	if [ info exists text(input_greeting) ] {
	    while { [ set what [ playtext $text(input_greeting) ] ] \
		    == "REPEAT" } {
	    }
	    if { $what == "HANGUP" } {
		return "HANGUP"
	    }
	    if { [ string index $what 0 ] == "*" } {
		vbox_breaklist rem ALL
		uninstall_actions_texts backup tbackup
		set tuning(returnsequenz) 0
		set input [ string trim $what "*#" ]
		return [ run_extern $cmd $input ]
	    }   
	} else {
	    raccess_log 2 "raccess_input: oops, no text(input_greeting)"
	    vbox_breaklist rem ALL
	    uninstall_actions_texts backup tbackup
	    set tuning(returnsequenz) 0
	    return [ handle_error $text(err_input_no_text)" ]
	}
    	if [ info exists text(input_wait) ] {
	    if { [ set what [ wait $text(input_wait) ] ] == "HANGUP" } {
		return "HANGUP"
	    }
	    if { [ string index $what 0 ] == "*" } {
		vbox_breaklist rem ALL
		uninstall_actions_texts backup tbackup
		set input [ string trim $what "*#" ]
		set tuning(returnsequenz) 0
		return [ run_extern $cmd $input ]
	    }   
	} else {
	    raccess_log 2 "raccess_input: oops, no text(input_wait)"
	}
    }
}

#
proc playheader { msgfile } {
    upvar #0 tuning(say_breath) breath
    set stmp [ vbox_message_info $msgfile 1 ]
    if { [ llength $stmp ] > 0 } {
	set day [ clock format $stmp -format %A ]
	set hor_min [ clock format $stmp -format %R ]
	lappend header $day $hor_min $breath
    }
    set cid [ vbox_message_info $msgfile 3 ]
    if { [ llength "$cid" ] > 0 } {
	if { "$cid" != "0" } {
	    for { set i 0 } { $i < [ string length "$cid" ] } { incr i } {
		lappend header [ string index "$cid" $i ] $breath
	    }
	} 
    }
    foreach item { 4 5 } {
	set who [ string trim [ vbox_message_info $msgfile $item ] {\{\}} ]
	if { [ llength $who ] > 0 } {
	    if { [ string match {*Unknown \**} $who ] != 1 } {
		lappend header $who $breath
	    }
	}
    }
    playtext $header
}

#
proc install_actions_texts { naction backup ntext tbackup} {
    global action atext
    upvar 1 $backup bup $naction nact $tbackup tbup $ntext ntxt

    raccess_log 2 "install_actions_texts"
    raccess_log 2 "install_actions_texts: vbox_breaklist rem all"
    vbox_breaklist rem all

    if [ info exists action ] {
	foreach item [ array names action ] {
	    raccess_log 2 \
		    "backup action($item) $action($item)"
	    set bup($item) $action($item)
	}
	unset action
    }
    if [ info exists atext ] {
	foreach item [ array names atext ] {
	    raccess_log 2 \
		    "backup atext($item) $atext($item)"
	    set tbup($item) $atext($item)
	}
	unset atext
    }

    foreach item [ array names nact ] {
	vbox_breaklist add $item
	set action($item) $nact($item)
	raccess_log 2 \
		"set action($item) $nact($item), vbox_breaklist add $item"
    }
    foreach item [ array names ntxt ] {
	set atext($item) $ntxt($item)
	raccess_log 2 \
		"set atext($item) $ntxt($item)"
    }
    
}

proc uninstall_actions_texts { backup tbackup } {
    global action atext
    upvar 1 $backup bup $tbackup tbup
    raccess_log 2 "uninstall_actions_texts: vbox_breaklist rem all"
    vbox_breaklist rem all
    if [ info exists action ] {
	unset action
    }
    foreach item [ array names bup ] {
	set action($item) $bup($item)
	vbox_breaklist add $item
	raccess_log 2 \
		"set action($item) $bup($item), vbox_breaklist add $item"
    }
    if [ info exists atext ] {
	unset atext
    }
    foreach item [ array names tbup ] {
	set atext($item) $tbup($item)
	raccess_log 2 \
		"set atext($item) $tbup($item)"
    }
}

proc install_texts { ntext tbackup} {
    global text
    upvar 1 $tbackup tbup $ntext ntxt

    raccess_log 2 "install_texts"
    foreach item [ array names ntxt ] {
	if [ info exists text($item) ] {
	    raccess_log 2 \
		    "backup text($item) $text($item)"
	    set tbup($item) $text($item)
	}
	set text($item) $ntxt($item)
	raccess_log 2 "setting text($item) $ntxt($item)"
    }
}

proc uninstall_texts { tbackup } {
    global text
    upvar 1 $tbackup tbup
    raccess_log 2 "uninstall_texts"

    if [ info exists tbup ] {
	foreach item [ array names tbup ] {
	    set text($item) $tbup($item)
	    raccess_log 2 \
		    "set text($item) $tbup($item)"
	}
    }
}

#
proc skip { } {
    return "OK"
}
proc repeat { } {
    return "REPEAT"
}

#
proc raccess_rewind { } {
    global message_no
    incr message_no -1
    if { $message_no < 0 } {
	set message_no 0
    }
    return "CONT"
}

proc raccess_forwind { } {
    global message_no
    incr message_no
    return "CONT"
}

proc raccess_first { } {
    global message_no
    set message_no 0
    return "CONT"
}

proc raccess_last { } {
    global message_no available_no raccess
    set message_no [ expr $available_no($raccess(mode)) - 1 ]
    return "CONT"
}

proc raccess_exit { } {
    return "EXIT"
}

proc raccess_switchmode { actual } {
    if { [ string compare $actual "old" ] == 0 } {
	return "new"
    } else {
	return "old"
    }
}

proc raccess_new-old { } {
    global raccess available_no message_no text raccess_text
    set other [ raccess_switchmode $raccess(mode) ]
    if { $available_no($other) == 0 } {
	if { [ playtext [ subst $raccess_text(noothermsg) ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	return "CONT"
    }
    set raccess(mode) $other
    set message_no 0
    raccess_log 2 "new_old: now $raccess(mode) Messages"
    if { [ playtext [ subst $raccess_text(howmanymsg) ] ] == "HANGUP" } {
	return "HANGUP"
    }
    return "CONT"
}

proc raccess_togglenew { } {
    global raccess vbox_var_checknew available available_no message_no text
    global raccess_text
    upvar #0 tuning(touch_path) touch
    set other [ raccess_switchmode $raccess(mode) ]
    set msgfile [ lindex $available($raccess(mode)) $message_no ]
    if { $raccess(mode) == "old" } {
	if [ catch { exec -- $touch -m $msgfile } ] {
	    if { [ playtext $raccess_text(err_togglenew) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "CONT"
	}
    } else {
	if [ catch \
		{ exec -- $touch -m -t 0101010070 $msgfile} ] {
	    if { [ playtext $raccess_text(err_toggleold) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "CONT"
	}
    }
    if { [ playtext [ subst $raccess_text(msgmarked) ] ] == "HANGUP" } {
	return "HANGUP"
    }
    raccess_getmessages $vbox_var_checknew
    if { $available_no($raccess(mode)) <= 0 } {
	return [ raccess_new-old ]
    }
    return "NOOP"
}

#
proc raccess_getmessages { dir } {  
    global available available_no text raccess_text raccess
    foreach item { new old } {
	if { [ info exists available($item) ] } {
	    unset available($item)
	}
    }
    foreach dum [ split [ exec ls -1tr $dir ] \n ] {
	if { [ file mtime $dir/$dum ] == 0 } {
	    lappend available(old) $dir/$dum
	} else {
	    lappend available(new) $dir/$dum
	}
    }
    foreach item { new old } {
	if { [ info exists available($item) ] } {
	    set available_no($item) [ llength $available($item) ]
	} else {
	    set available_no($item) 0
	}
    }
    if { [ playtext [ subst $raccess_text(howmanymsg) ] ] == "HANGUP" } {
	return "HANGUP"
    }

}

#
proc rcontrol_recnewstdmsg { } {
    global vbox_msg_beep vbox_var_spooldir text raccess
    set stdnew $vbox_var_spooldir/$raccess(messagedir)/standard.msg.new
    set stdold $vbox_var_spooldir/$raccess(messagedir)/standard.msg.old
    set std    $vbox_var_spooldir/$raccess(messagedir)/standard.msg
    if { [ playtext $text(rcontrol_recnew_intro) ] == "HANGUP" } {
	return "HANGUP"
    }
    if { [ playmessage $vbox_msg_beep ] == "HANGUP" } {
	return "HANGUP"
    }
    if { [ recmessage $stdnew 120 ] == "HANGUP" } {
	return "HANGUP"
    }
    while { 1 } {
	if { [ playtext $text(rcontrol_recnew_repeatrec) ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { [ set what [ playmessage $stdnew ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { $what == "REPEAT" } {
	    if [ catch { exec -- mv $std $stdold } ] {
		return [ handle_error $text(rcontrol_recnew_err_backupstd) ]
	    }
	    if [ catch { exec -- mv $stdnew $std } ] {
		return [ handle_error $text(rcontrol_recnew_err_createstd) ]
	    }
	    if { [ playtext $text(rcontrol_recnew_confirm) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
	if { $what == "EXIT" } {
	    if { [ playtext $text(rcontrol_recnew_drop) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
    }
}

#
proc run_mode_exit { } {
    return "EXIT"
}

#
proc run_mode { name } {
    upvar #0 ${name}_action m_action ${name}_action_text m_text \
	    ${name}_text mg_text ${name}(greeting) greeting \
	    ${name}(wait) sec
    
    install_actions_texts m_action backup m_text tbackup
    install_texts mg_text tgbackup
    
    if { ! [ info exists greeting ] } {
	raccess_log 2 "run_mode $name: no greeting, exiting"
	return "REPEAT"
    }
    while { 1 } {
	while { [ set what [ playtext $greeting ] ] \
		== "REPEAT" } { }
	if { $what == "HANGUP" } {
	    return "HANGUP"
	}
	if { $what == "EXIT" } {
	    uninstall_actions_texts backup tbackup
	    uninstall_texts tgbackup
	    return "REPEAT"
	}
	if [ info exists sec ] {
	    if { [ set what [ wait $sec ] ] == "HANGUP" } {
		return "HANGUP"
	    }
	    if { $what == "EXIT" } {
		uninstall_actions_texts backup tbackup
		uninstall_texts tgbackup
		return "REPEAT"
	    }
	}
    }
}

#
proc raccess { } {
    global action text available available_no message_no raccess_text \
	    vbox_var_checknew raccess
    upvar #0 raccess_action r_action raccess_action_text r_text \
	    raccess_text rg_text

    install_actions_texts r_action backup r_text tbackup
    install_texts rg_text gtbackup

    set message_no 0
    set working 1
    raccess_getmessages $vbox_var_checknew
    if { $available_no(new) == 0 } {
	set raccess(mode) "old"
	if { [ playtext [ subst $raccess_text(howmanymsg) ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { $available_no(old) == 0 } {
	    if { [ playtext $raccess_text(no_msg) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    uplevel { vbox_breaklist add $what }
	    return "REPEAT"
	}
    }

    while { $working } {
	set msgfile [ lindex $available($raccess(mode)) $message_no ]
	while { [ set what [ playheader $msgfile ] ] == "REPEAT" } { }
	if { $what == "HANGUP" } { return "HANGUP" }
	if { $what == "EXIT" } {
	    set working 0
	    continue
	}
	if { $what != "CONT" } {
	    if { [ set what [ playmessage $msgfile ] ] == "HANGUP" } {
		return "HANGUP"
	    }
	    if { $what == "EXIT" } {
		set working 0
		continue
	    }
	    if { $what == "OK" } { incr message_no }
	}
	if { $message_no >= $available_no($raccess(mode)) } {
	    set message_no [ expr $available_no($raccess(mode)) - 1 ]
	    if { [ playtext $raccess_text(last_msg) ] == "HANGUP" } {
		return "HANGUP"
	    }
	}
	if { $available_no($raccess(mode)) == 0 } {
	    raccess_new-old
	}
    }

    uninstall_actions_texts backup tbackup
    uninstall_texts gtbackup

    return "REPEAT"
}

proc answeringmachine { } {
    upvar #0 answeringmachine_action a_action \
	    answeringmachine_action_text a_text \
	    answeringmachine_text gt_text
    global vbox_msg_standard vbox_flag_standard vbox_msg_beep \
	    vbox_flag_beep vbox_var_checknew vbox_var_savename \
	    vbox_var_rectime vbox_flag_record text raccess \
	    vbox_user_name vbox_caller_id

    install_actions_texts a_action backup a_text tbackup
    install_texts gt_text gtbackup
    while { [ set what [ playmessage $vbox_msg_standard $vbox_flag_standard ] ] \
	    == "REPEAT" } { }
    if { $what == "HANGUP" } {
	return
    }
    while { [ set what [ playmessage $vbox_msg_beep $vbox_flag_beep ] ] \
	    == "REPEAT" } { }
    if { $what == "HANGUP" } {
	return
    }
    while { [ set what [ recmessage $vbox_var_checknew/$vbox_var_savename \
	    $vbox_var_rectime $vbox_flag_record ] ] == "REPEAT" } {
	if { [ playtext $text(repeat_rec) ] == "HANGUP" } {
	    break
	}
    }
    uninstall_actions_texts backup tbackup
    uninstall_texts gtbackup

    # reached this point, a message is recorded....
    # handle record
    
    if { [ info exists raccess(callhandler) ] } {
	raccess_log 2 \
		"Running callhandler: $raccess(callhandler) $vbox_var_savename $vbox_caller_id $vbox_user_name"
	if [ catch { exec -- $raccess(callhandler) \
		$vbox_var_checknew/$vbox_var_savename $vbox_caller_id $vbox_user_name } that ] {
	    raccess_log 2 "Error on running callhandler: $that"
	}
    }
}

# main, running right after accepting the call.

set no_of_errors 0
if { $tuning(logging) } {
    if [ catch { set tuning(log_file_no) \
	    [ open $vbox_var_spooldir/$tuning(log_file) a+ 0644 ] } ] {
	set tuning(logging) 0
    } else {
	raccess_log 1 "-------------------------"
	raccess_log 1 \
	  "call from $vbox_caller_id $vbox_caller_phone $vbox_caller_name"
    }
}
# read config file
if [ file readable $vbox_var_spooldir/$tuning(rcfile) ] {
    set rc [ open $vbox_var_spooldir/$tuning(rcfile) r ]
    for { set i 1 } { ! [ eof $rc ] } { incr i } {
	if { [ gets $rc line ] == 0 } { continue }
	if { [ set no [ string first ";" $line ] ] != -1 } {
	    set line [ string range $line 0 [ expr $no - 1 ] ]
	}
	if { [ llength $line ] == 0 } { continue }
	set word [ lindex $line 0 ]
	if { [ string index $word 0 ] == "\[" } {
	    set arrname [ string trim $word \[\] ]
	    raccess_log 2 "arrname == $word"
	} else {
	    if { [ llength $line ] >= 2 } {
		if [ info exists arrname ] {
		    set ${arrname}($word) [ lindex $line 1 ]
		    raccess_log 2 \
			    "setting ${arrname}($word) [ lindex $line 1 ]"
		    if { [ llength $line ] == 3 } {
			set ${arrname}_text($word) [ lindex $line 2 ]
			raccess_log 2 \
			   "setting ${arrname}_text($word) [ lindex $line 2 ]"
		    }
		} else {
		    raccess_log 2 "oops: no arrname set"
		}
	    } else {
		raccess_log 1 \
			"raccess_readrc: at least 2 words expected in line $i"
	    }
	} 
    }
    catch { close $rc }
    foreach item [ array name action_text ] {
	set atext($item) $action_text($item)
    }
}

if [ info exists start(mode) ] {
    set tuning(mode) $start(mode)
    eval $start(mode)
} else {
    raccess_log 0 "no starting mode defined, nothing to do!!"
}

if { $tuning(logging) } {
    catch { close $tuning(log_file_no) }
}

# Return to vboxgetty at the end of the Script
return
